# VARIABLES
variables:
  DOCKER_BUILDKIT: 1
  DOCKER_DRIVER: overlay2
  DOCKER_HOST: tcp://localhost:2375
  DOCKER_TLS_CERTDIR: ""

##########################################################################################################

## PIPELINE DEFINITION
stages:
  - check
  - deploy

##########################################################################################################

### COMMON SECTION
.common: &common
  image: registry.cyberbrain.pw/ansible/ansible
  before_script:
    - chmod -R o-w ../

##########################################################################################################

### CHECK SECTION
check:
  <<: *common
  stage: check
  variables:
    GIT_DEPTH: 1
    ANSIBLE_FORCE_COLOR: "True"
    ANSIBLE_HOST_KEY_CHECKING: "False"
  only:
    refs:
      - trunk
  script:
    - echo "Checking inventory"
    - ansible-inventory -i inventory.ini --graph
    - ansible -i inventory.ini -m ping all -u ${USERNAME:-maintenance}

##########################################################################################################

### DEPLOY SECTION
deploy:
  <<: *common
  stage: deploy
  variables:
    GIT_DEPTH: 1
    ANSIBLE_FORCE_COLOR: "True"
    ANSIBLE_HOST_KEY_CHECKING: "False"
    ANSIBLE_STDOUT_CALLBACK: "actionable"
    GIT_URL:
      value: ""
      description: "ОБЯЗАТЕЛЬНАЯ ПЕРЕМЕННАЯ: http(s) адрес репозитория системной конфигурации"
    GIT_LOGIN:
      value: ""
      description: "НЕобязательная переменная: логин репозитория системной конфигурации"
    GIT_PASSWORD:
      value: ""
      description: "НЕобязательная переменная: пароль репозитория системной конфигурации"
  only:
    refs:
      - master
    variables:
      - $GIT_URL =~ /^\S+$/
  script:
    - echo "Deploying configuration [${GIT_URL}] with parameters [${PARAMETERS}]"
    - export INVENTORY_DIRECTORY="`pwd`"
    - git config --global credential.helper store && echo "https://${GIT_LOGIN}:${GIT_PASSWORD}@$(echo ${GIT_URL} | sed -r 's#([^/])/[^/].*#\1#' | sed -e 's|https://||g')" > ~/.git-credentials
    - mkdir -p /tmp/checkout && git clone "${GIT_URL}" /tmp/checkout && cd /tmp/checkout
    - |
      export ANSIBLE_CONFIG="${INVENTORY_DIRECTORY}/ansible.cfg"
      if [ -s ansible.cfg ]; then
        export ANSIBLE_CONFIG=ansible.cfg
      fi

      if [ -s run.sh ]; then
        sh run.sh
      elif [ -s "${PLAYBOOK:-deploy.yml}" ]; then
        if [ -s requirements.yml ]; then
          ansible-galaxy install -r requirements.yml
        fi
        ansible-playbook ${PARAMETERS} -u ${USERNAME:-maintenance} -i "${INVENTORY_DIRECTORY}/inventory.ini" "${PLAYBOOK:-deploy.yml}"
      else
        echo "Error - no actions available!"
        exit 1
      fi
